diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 3800df8cf..b59005a58 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -5,6 +5,7 @@ import java.util.Random;
 
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
@@ -32,17 +33,15 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.SynchedEntityData;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public abstract class Entity
-    implements IVehicle
-{
-    private static @NotNull AABB DEFAULT_AABB = AABB.fromPool(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
-
+    implements IVehicle {
     public static final int DATA_SHARED_FLAGS_ID = 0;
     public static final int FLAG_ONFIRE = 0;
     public static final int FLAG_SNEAKING = 1;
@@ -70,7 +69,7 @@ public abstract class Entity
     public float xRotO;
     public float pushTime;
     public int pushesThisTick;
-    public final @NotNull AABB bb = Entity.DEFAULT_AABB.copyUnpooled();
+    public final @NotNull AABBd bb = new AABBd();
     public boolean onGround = false;
     public boolean horizontalCollision;
     public boolean verticalCollision;
@@ -124,86 +123,69 @@ public abstract class Entity
     public boolean turnWithVehicle = true;
 
     public Entity(final @NotNull World world) {
-        assert world != null : "Entity world must not be null! If no world ref available try using WorldClient.EMPTY_WORLD as a stub!";
         this.world = world;
         setPos(0.0D, 0.0D, 0.0D);
-        entityData.define(DATA_SHARED_FLAGS_ID, (byte) 0, Byte.class);
+        this.entityData.define(DATA_SHARED_FLAGS_ID, (byte) 0, Byte.class);
         defineSynchedData();
     }
 
     protected abstract void defineSynchedData();
 
-    public void spawnInit()
-    {
+    public void spawnInit() {
     }
 
-    public @NotNull SynchedEntityData getEntityData()
-    {
-        return entityData;
+    public @NotNull SynchedEntityData getEntityData() {
+        return this.entityData;
     }
 
     @Override
-	public boolean equals(@Nullable Object that)
-    {
-        if(that instanceof Entity)
-        {
-            return ((Entity)that).id == id;
-        }
-        else
-        {
+    public boolean equals(@Nullable Object that) {
+        if (that instanceof Entity) {
+            return ((Entity) that).id == this.id;
+        } else {
             return false;
         }
     }
 
     @Override
-    public int hashCode()
-    {
-        return id;
+    public int hashCode() {
+        return this.id;
     }
 
-    protected void resetPos()
-    {
-        do
-        {
-            if(y <= 0.0D)
-            {
+    protected void resetPos() {
+        do {
+            if (this.y <= 0.0D) {
                 break;
             }
-            setPos(x, y, z);
-            if(world.getCubes(this, bb).isEmpty())
-            {
+            setPos(this.x, this.y, this.z);
+            if (this.world.getCubes(this, this.bb).isEmpty()) {
                 break;
             }
-            y++;
-        } while(true);
-        xd = yd = zd = 0.0D;
-        xRot = 0.0F;
+            this.y++;
+        } while (true);
+        this.xd = this.yd = this.zd = 0.0D;
+        this.xRot = 0.0F;
     }
 
-    public void remove()
-    {
-        removed = true;
+    public void remove() {
+        this.removed = true;
     }
 
-    public boolean showBoundingBoxOnHover()
-    {
+    public boolean showBoundingBoxOnHover() {
         return false;
     }
 
-    protected final void setSize(float width, float height)
-    {
+    protected final void setSize(float width, float height) {
         this.bbWidth = width;
         this.bbHeight = height;
     }
 
-    public final void setRot(float yRot, float xRot)
-    {
+    public final void setRot(float yRot, float xRot) {
         this.yRot = yRot % 360F;
         this.xRot = xRot % 360F;
     }
 
-    public void setPos(final double x, final double y, final double z)
-    {
+    public void setPos(final double x, final double y, final double z) {
         this.x = x;
         this.y = y;
         this.z = z;
@@ -213,56 +195,51 @@ public abstract class Entity
     public void setBounds() {
         final double center = this.bbWidth / 2.0d;
         final double heightOfMob = this.bbHeight;
-        this.bb.set(
-            x - center,
-            (y - (double) this.heightOffset) + (double) this.ySlideOffset,
-            z - center,
-            x + center,
-            (y - (double) this.heightOffset) + (double) this.ySlideOffset + heightOfMob,
-            z + center);
+        this.bb.setMin(
+            this.x - center,
+            (this.y - (double) this.heightOffset) + (double) this.ySlideOffset,
+            this.z - center);
+        this.bb.setMax(
+            this.x + center,
+            (this.y - (double) this.heightOffset) + (double) this.ySlideOffset + heightOfMob,
+            this.z + center);
     }
 
-    public void interpolateTurn(float yRot, float xRot)
-    {
+    public void interpolateTurn(float yRot, float xRot) {
         float xRotCurrent = this.xRot;
         float yRotCurrent = this.yRot;
-        this.yRot += (double)yRot * 0.15D;
-        this.xRot -= (double)xRot * 0.15D;
-        if(this.xRot < -90F)
-        {
+        this.yRot += (double) yRot * 0.15D;
+        this.xRot -= (double) xRot * 0.15D;
+        if (this.xRot < -90F) {
             this.xRot = -90F;
         }
-        if(this.xRot > 90F)
-        {
+        if (this.xRot > 90F) {
             this.xRot = 90F;
         }
-        xRotO += this.xRot - xRotCurrent;
-        yRotO += this.yRot - yRotCurrent;
+        this.xRotO += this.xRot - xRotCurrent;
+        this.yRotO += this.yRot - yRotCurrent;
     }
 
-    public void tick()
-    {
+    public void tick() {
         baseTick();
     }
 
-    public void baseTick()
-    {
-        pushesThisTick = 0;
-        pushTime *= 0.98f;
-        if (pushTime < 0.001f){
-            pushTime = 0;
-        }
-        if(vehicle != null && vehicle.isRemoved())
-        {
-            vehicle = null;
-        }
-        tickCount++;
-        walkDistO = walkDist;
-        xo = x;
-        yo = y;
-        zo = z;
-        xRotO = xRot;
-        yRotO = yRot;
+    public void baseTick() {
+        this.pushesThisTick = 0;
+        this.pushTime *= 0.98f;
+        if (this.pushTime < 0.001f) {
+            this.pushTime = 0;
+        }
+        if (this.vehicle != null && this.vehicle.isRemoved()) {
+            this.vehicle = null;
+        }
+        this.tickCount++;
+        this.walkDistO = this.walkDist;
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.xRotO = this.xRot;
+        this.yRotO = this.yRot;
         // Removed at jonks request, should work though if it ever wants to be uncommented
 //        if (isSprinting())
 //        {
@@ -286,158 +263,132 @@ public abstract class Entity
 
         checkOnWater(true);
 
-        if(world.isClientSide)
-        {
-            remainingFireTicks = 0;
-        }
-        else if (remainingFireTicks > 0)
-        {
-            if (fireImmune)
-            {
-                remainingFireTicks -= 4;
-                if (remainingFireTicks < 0)
-                {
-                    remainingFireTicks = 0;
+        if (this.world.isClientSide) {
+            this.remainingFireTicks = 0;
+        } else if (this.remainingFireTicks > 0) {
+            if (this.fireImmune) {
+                this.remainingFireTicks -= 4;
+                if (this.remainingFireTicks < 0) {
+                    this.remainingFireTicks = 0;
                 }
-            }
-            else
-            {
-                if (remainingFireTicks % 20 == 0)
-                {
+            } else {
+                if (this.remainingFireTicks % 20 == 0) {
                     hurt(null, 1, DamageType.FIRE);
                 }
-                remainingFireTicks--;
+                this.remainingFireTicks--;
             }
         }
-        if (soundCooldown > 0){
-            soundCooldown--;
+        if (this.soundCooldown > 0) {
+            this.soundCooldown--;
         }
 
-        if (isInLava())
-        {
+        if (isInLava()) {
             lavaHurt();
         }
-        if (isInWater())
-        {
+        if (isInWater()) {
             waterHurt();
         }
 
-        if (y < -64D)
-        {
+        if (this.y < -64D) {
             outOfWorld();
         }
 
-        if (!world.isClientSide)
-        {
-            setSharedFlag(FLAG_ONFIRE, remainingFireTicks > 0);
-            setSharedFlag(FLAG_RIDING, vehicle != null);
+        if (!this.world.isClientSide) {
+            setSharedFlag(FLAG_ONFIRE, this.remainingFireTicks > 0);
+            setSharedFlag(FLAG_RIDING, this.vehicle != null);
         }
 
-        firstTick = false;
+        this.firstTick = false;
     }
+
     protected void checkOnWater(boolean addVelocity) {
-        if (checkAndHandleWater(addVelocity))
-        {
-            if(!wasInWater && !firstTick)
-            {
-                float f = MathHelper.sqrt(xd * xd * 0.2D + yd * yd + zd * zd * 0.2D) * 0.2F;
-                if(f > 1.0F)
-                {
+        if (checkAndHandleWater(addVelocity)) {
+            if (!this.wasInWater && !this.firstTick) {
+                float f = MathHelper.sqrt(this.xd * this.xd * 0.2D + this.yd * this.yd + this.zd * this.zd * 0.2D) * 0.2F;
+                if (f > 1.0F) {
                     f = 1.0F;
                 }
 
-                if (!Global.isServer){
-                    world.playSoundAtEntity(null, this, "random.splash", f, 1.0F + (random.nextFloat() - random.nextFloat()) * 0.4F);
+                if (!Global.isServer) {
+                    this.world.playSoundAtEntity(null, this, "random.splash", f, 1.0F + (this.random.nextFloat() - this.random.nextFloat()) * 0.4F);
                 } else {
-                    if(!world.isClientSide && soundCooldown == 0) {
-                        soundCooldown = 2;
-                        world.playSoundAtEntity(this, this, "random.splash", f, 1.0F + (random.nextFloat() - random.nextFloat()) * 0.4F);
+                    if (!this.world.isClientSide && this.soundCooldown == 0) {
+                        this.soundCooldown = 2;
+                        this.world.playSoundAtEntity(this, this, "random.splash", f, 1.0F + (this.random.nextFloat() - this.random.nextFloat()) * 0.4F);
                     }
                 }
-                
-                float f1 = MathHelper.floor(bb.minY);
-                for(int i = 0; (float)i < 1.0F + bbWidth * 20F; i++)
-                {
-                    double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                    double offZ = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                    world.spawnParticle("bubble", x + offX, f1 + 1.0F, z + offZ, xd, yd - (double)(random.nextFloat() * 0.2F), zd, 0);
+
+                float f1 = MathHelper.floor(this.bb.minY);
+                for (int i = 0; (float) i < 1.0F + this.bbWidth * 20F; i++) {
+                    double offX = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
+                    double offZ = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
+                    this.world.spawnParticle("bubble", this.x + offX, f1 + 1.0F, this.z + offZ, this.xd, this.yd - (double) (this.random.nextFloat() * 0.2F), this.zd, 0);
                 }
 
-                for(int j = 0; (float)j < 1.0F + bbWidth * 20F; j++)
-                {
-                    double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                    double offZ = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
-                    world.spawnParticle("splash", x + offX, f1 + 1.0F, z + offZ, xd, yd, zd, 0);
+                for (int j = 0; (float) j < 1.0F + this.bbWidth * 20F; j++) {
+                    double offX = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
+                    double offZ = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
+                    this.world.spawnParticle("splash", this.x + offX, f1 + 1.0F, this.z + offZ, this.xd, this.yd, this.zd, 0);
                 }
             }
-            fallDistance = 0.0F;
-            wasInWater = true;
-            remainingFireTicks = 0;
-        }
-        else
-        {
-            wasInWater = false;
+            this.fallDistance = 0.0F;
+            this.wasInWater = true;
+            this.remainingFireTicks = 0;
+        } else {
+            this.wasInWater = false;
         }
     }
 
     public void waterHurt() {
-        if (world.dimension == Dimension.NETHER && !(vehicle instanceof EntityBoat)) {
+        if (this.world.dimension == Dimension.NETHER && !(this.vehicle instanceof EntityBoat)) {
             hurt(null, 1, DamageType.FIRE);
         }
     }
 
-    public void lavaHurt()
-    {
-        if(!fireImmune)
-        {
+    public void lavaHurt() {
+        if (!this.fireImmune) {
             hurt(null, 4, DamageType.FIRE);
-            remainingFireTicks = 600;
-            maxFireTicks = remainingFireTicks;
+            this.remainingFireTicks = 600;
+            this.maxFireTicks = this.remainingFireTicks;
         }
     }
 
-    public void fireHurt()
-    {
-        if(!fireImmune)
-        {
+    public void fireHurt() {
+        if (!this.fireImmune) {
             hurt(null, 1, DamageType.FIRE);
-            remainingFireTicks = 300;
-            maxFireTicks = remainingFireTicks;
+            this.remainingFireTicks = 300;
+            this.maxFireTicks = this.remainingFireTicks;
         }
     }
 
-    public void outOfWorld()
-    {
+    public void outOfWorld() {
         remove();
     }
 
-    public boolean isFree(double x, double y, double z)
-    {
-        AABB offsetBb = bb.cloneMove(x, y, z).grow(-0.01, -0.01, -0.01);
-        List<AABB> list = world.getCubes(this, offsetBb);
-        if(!list.isEmpty())
-        {
+    public boolean isFree(double x, double y, double z) {
+        AABBd offsetBb = new AABBd();
+        MathHelper.aabbGrow(this.bb.translate(x, y, z, offsetBb), -0.01, -0.01, -0.01, offsetBb);
+
+        List<AABBdc> list = this.world.getCubes(this, offsetBb);
+        if (!list.isEmpty()) {
             return false;
         }
-        return !world.getIsAnyLiquid(offsetBb);
+        return !this.world.getIsAnyLiquid(offsetBb);
     }
 
-    public void move(double xd, double yd, double zd)
-    {
-        if(noPhysics)
-        {
-        	onGround = false;
-            bb.move(xd, yd, zd);
-            this.x = (bb.minX + bb.maxX) / 2.0;
-            this.y = (bb.minY + heightOffset) - ySlideOffset;
-            this.z = (bb.minZ + bb.maxZ) / 2.0;
+    public void move(double xd, double yd, double zd) {
+        if (this.noPhysics) {
+            this.onGround = false;
+            this.bb.translate(xd, yd, zd);
+            this.x = (this.bb.minX + this.bb.maxX) / 2.0;
+            this.y = (this.bb.minY + this.heightOffset) - this.ySlideOffset;
+            this.z = (this.bb.minZ + this.bb.maxZ) / 2.0;
             return;
         }
-        ySlideOffset *= 0.4f;
+        this.ySlideOffset *= 0.4f;
         double d3 = this.x;
         double d4 = this.z;
-        if(stuckInCobweb)
-        {
+        if (this.stuckInCobweb) {
             // Restricts all movement
             xd *= 0.25;
             this.xd = 0.0;
@@ -448,10 +399,9 @@ public abstract class Entity
             // Cancels the player's jump
             this.yd = 0.0;
 
-            stuckInCobweb = false;
+            this.stuckInCobweb = false;
         }
-        if(stuckInSpikes)
-        {
+        if (this.stuckInSpikes) {
             // Restricts all horizontal movement
             xd *= 0.25;
             this.xd = 0.0;
@@ -461,194 +411,194 @@ public abstract class Entity
             // Cancels the player's jump
             this.yd = 0.0;
 
-            stuckInSpikes = false;
+            this.stuckInSpikes = false;
         }
         double oldXd = xd;
         double oldYd = yd;
         double oldZd = zd;
-        AABB bbCopy = bb.copy();
-        
-        double bbWidth = bb.maxX - bb.minX - 0.05;
-        if(isSneaking()) { // Edge safety behavior
-			if(xd != 0.0) {
-				AABB floor = AABB.fromPool(bb.minX, bb.minY - 1.0, bb.minZ, bb.maxX, bb.minY, bb.maxZ).expand(xd, 0.0, 0.0);
-				List<AABB> collidingBoxes = world.getCubes(this, floor);
-				if(!collidingBoxes.isEmpty()) {
-					double limitX = 0.0;
-					for(int i=0; i < collidingBoxes.size(); i++) {
-						AABB bb1 = collidingBoxes.get(i);
-						if(xd < 0.0) {
-							limitX = Math.min(limitX, bb1.minX - bbWidth - bb.minX);
-						}else {
-							limitX = Math.max(limitX, bb1.maxX + bbWidth - bb.maxX);
-						}
-					}
-					if(xd < 0.0) {
-						oldXd = xd = Math.max(xd, limitX);
-					}else {
-						oldXd = xd = Math.min(xd, limitX);
-					}
-				}
-			}
-			if(zd != 0.0) {
-				AABB floor = AABB.fromPool(bb.minX, bb.minY - 1.0, bb.minZ, bb.maxX, bb.minY, bb.maxZ).expand(0.0, 0.0, zd);
-				List<AABB> collidingBoxes = world.getCubes(this, floor);
-				if(!collidingBoxes.isEmpty()) {
-					double limitZ = 0.0;
-					for(int i=0; i < collidingBoxes.size(); i++) {
-						AABB bb1 = collidingBoxes.get(i);
-						if(zd < 0.0) {
-							limitZ = Math.min(limitZ, bb1.minZ - bbWidth - bb.minZ);
-						}else {
-							limitZ = Math.max(limitZ, bb1.maxZ + bbWidth - bb.maxZ);
-						}
-					}
-					if(zd < 0.0) {
-						oldZd = zd = Math.max(zd, limitZ);
-					}else {
-						oldZd = zd = Math.min(zd, limitZ);
-					}
-				}
-			}
-        }
-        
-		List<AABB> cubes = world.getCubes(this, bb.expand(xd, yd, zd));
-		
-		// Check collision on Y Axis
-		for(int i = 0; i < cubes.size(); i++) {
-			yd = cubes.get(i).clipYCollide(bb, yd);
-		}
-
-		bb.move(0.0, yd, 0.0);
-		if(!slide && oldYd != yd) {
-			xd = yd = zd = 0.0;
-		}
-		
-		// Check collision on X Axis
-		for(int i = 0; i < cubes.size(); i++) {
-			xd = cubes.get(i).clipXCollide(bb, xd);
-		}
-
-		bb.move(xd, 0.0D, 0.0D);
-		if(!slide && oldXd != xd) {
-			xd = yd = zd = 0.0;
-		}
-		
-		// Check collision on Z Axis
-		for(int i = 0; i < cubes.size(); i++) {
-			zd = cubes.get(i).clipZCollide(bb, zd);
-		}
-		bb.move(0.0D, 0.0D, zd);
-		if(!slide && oldZd != zd) {
-			xd = yd = zd = 0.0;
-		}
-
-		boolean touchedGround = onGround || oldYd != yd && oldYd < 0.0;
-		boolean touchedWall = oldXd != xd || oldZd != zd;
-		
-		// Handle steps
-		if(footSize > 0.0f && touchedGround && touchedWall && (isSneaking() || ySlideOffset < 0.05f)) {
-			double oldX = xd;
-			double oldY = yd;
-			double oldZ = zd;
-			xd = oldXd;
-			yd = footSize;
-			zd = oldZd;
-			AABB axisalignedbb1 = bb.copy();
-			bb.setBB(bbCopy);
-			cubes = world.getCubes(this, bb.expand(xd, 0.0, zd));
-			for(int i = 0; i < cubes.size(); i++) {
-				yd = cubes.get(i).clipYCollide(bb, yd);
-			}
-
-			bb.move(0.0D, yd, 0.0D);
-			if(!slide && oldYd != yd) {
-				xd = yd = zd = 0.0D;
-			}
-			for(int i = 0; i < cubes.size(); i++) {
-				xd = cubes.get(i).clipXCollide(bb, xd);
-			}
-
-			bb.move(xd, 0.0D, 0.0D);
-			if(!slide && oldXd != xd) {
-				xd = yd = zd = 0.0D;
-			}
-			for(int i = 0; i < cubes.size(); i++) {
-				zd = cubes.get(i).clipZCollide(bb, zd);
-			}
-
-			bb.move(0.0D, 0.0D, zd);
-			if(!slide && oldZd != zd) {
-				xd = yd = zd = 0.0D;
-			}
-			if(!slide && oldYd != yd) {
-				xd = yd = zd = 0.0D;
-			}else {
-				yd = -footSize;
-				for(AABB aabb : cubes) {
-					yd = aabb.clipYCollide(bb, yd);
-				}
-
-				bb.move(0.0D, yd, 0.0D);
-			}
-			cubes = world.getCubes(this, bb);
-			if(oldX * oldX + oldZ * oldZ >= xd * xd + zd * zd || !cubes.isEmpty()) {
-				xd = oldX;
-				yd = oldY;
-				zd = oldZ;
-				bb.setBB(axisalignedbb1);
-			}
-		}
+        AABBd bbCopy = new AABBd(this.bb);
+
+        double bbWidth = this.bb.maxX - this.bb.minX - 0.05;
+        if (isSneaking()) { // Edge safety behavior
+            if (xd != 0.0) {
+                AABBd floor = new AABBd(this.bb.minX, this.bb.minY - 1.0, this.bb.minZ, this.bb.maxX, this.bb.minY, this.bb.maxZ);
+                MathHelper.aabbExpand(floor, xd, 0.0, 0.0, floor);
+                List<AABBdc> collidingBoxes = this.world.getCubes(this, floor);
+                if (!collidingBoxes.isEmpty()) {
+                    double limitX = 0.0;
+                    for (int i = 0; i < collidingBoxes.size(); i++) {
+                        AABBdc bb1 = collidingBoxes.get(i);
+                        if (xd < 0.0) {
+                            limitX = Math.min(limitX, bb1.minX() - bbWidth - this.bb.minX);
+                        } else {
+                            limitX = Math.max(limitX, bb1.maxX() + bbWidth - this.bb.maxX);
+                        }
+                    }
+                    if (xd < 0.0) {
+                        oldXd = xd = Math.max(xd, limitX);
+                    } else {
+                        oldXd = xd = Math.min(xd, limitX);
+                    }
+                }
+            }
+            if (zd != 0.0) {
+                AABBd floor = new AABBd(this.bb.minX, this.bb.minY - 1.0, this.bb.minZ, this.bb.maxX, this.bb.minY, this.bb.maxZ);
+                MathHelper.aabbExpand(floor, 0.0, 0.0, zd, floor);
+                List<AABBdc> collidingBoxes = this.world.getCubes(this, floor);
+                if (!collidingBoxes.isEmpty()) {
+                    double limitZ = 0.0;
+                    for (int i = 0; i < collidingBoxes.size(); i++) {
+                        AABBdc bb1 = collidingBoxes.get(i);
+                        if (zd < 0.0) {
+                            limitZ = Math.min(limitZ, bb1.minZ() - bbWidth - this.bb.minZ);
+                        } else {
+                            limitZ = Math.max(limitZ, bb1.maxZ() + bbWidth - this.bb.maxZ);
+                        }
+                    }
+                    if (zd < 0.0) {
+                        oldZd = zd = Math.max(zd, limitZ);
+                    } else {
+                        oldZd = zd = Math.min(zd, limitZ);
+                    }
+                }
+            }
+        }
+
+        List<AABBdc> cubes = this.world.getCubes(this, MathHelper.aabbExpand(this.bb, xd, yd, zd, new AABBd()));
+
+        // Check collision on Y Axis
+        for (int i = 0; i < cubes.size(); i++) {
+            yd = MathHelper.aabbClipYCollide(cubes.get(i), this.bb, yd);
+        }
+
+        this.bb.translate(0.0, yd, 0.0);
+        if (!this.slide && oldYd != yd) {
+            xd = yd = zd = 0.0;
+        }
+
+        // Check collision on X Axis
+        for (int i = 0; i < cubes.size(); i++) {
+            xd = MathHelper.aabbClipXCollide(cubes.get(i), this.bb, xd);
+        }
+
+        this.bb.translate(xd, 0.0D, 0.0D);
+        if (!this.slide && oldXd != xd) {
+            xd = yd = zd = 0.0;
+        }
+
+        // Check collision on Z Axis
+        for (int i = 0; i < cubes.size(); i++) {
+            zd = MathHelper.aabbClipZCollide(cubes.get(i), this.bb, zd);
+        }
+        this.bb.translate(0.0D, 0.0D, zd);
+        if (!this.slide && oldZd != zd) {
+            xd = yd = zd = 0.0;
+        }
+
+        boolean touchedGround = this.onGround || oldYd != yd && oldYd < 0.0;
+        boolean touchedWall = oldXd != xd || oldZd != zd;
+
+        // Handle steps
+        if (this.footSize > 0.0f && touchedGround && touchedWall && (isSneaking() || this.ySlideOffset < 0.05f)) {
+            double oldX = xd;
+            double oldY = yd;
+            double oldZ = zd;
+            xd = oldXd;
+            yd = this.footSize;
+            zd = oldZd;
+            AABBd aabbCopy = new AABBd(this.bb);
+            this.bb.set(bbCopy);
+            cubes = this.world.getCubes(this, MathHelper.aabbExpand(this.bb, xd, 0.0, zd, new AABBd()));
+            for (int i = 0; i < cubes.size(); i++) {
+                yd = MathHelper.aabbClipYCollide(cubes.get(i), this.bb, yd);
+            }
+
+            this.bb.translate(0.0D, yd, 0.0D);
+            if (!this.slide && oldYd != yd) {
+                xd = yd = zd = 0.0D;
+            }
+            for (int i = 0; i < cubes.size(); i++) {
+                xd = MathHelper.aabbClipXCollide(cubes.get(i), this.bb, xd);
+            }
+
+            this.bb.translate(xd, 0.0D, 0.0D);
+            if (!this.slide && oldXd != xd) {
+                xd = yd = zd = 0.0D;
+            }
+            for (int i = 0; i < cubes.size(); i++) {
+                zd = MathHelper.aabbClipZCollide(cubes.get(i), this.bb, zd);
+            }
+
+            this.bb.translate(0.0D, 0.0D, zd);
+            if (!this.slide && oldZd != zd) {
+                xd = yd = zd = 0.0D;
+            }
+            if (!this.slide && oldYd != yd) {
+                xd = yd = zd = 0.0D;
+            } else {
+                yd = -this.footSize;
+                for (AABBdc aabb : cubes) {
+                    yd = MathHelper.aabbClipYCollide(aabb, this.bb, yd);
+                }
+
+                this.bb.translate(0.0D, yd, 0.0D);
+            }
+            cubes = this.world.getCubes(this, this.bb);
+            if (oldX * oldX + oldZ * oldZ >= xd * xd + zd * zd || !cubes.isEmpty()) {
+                xd = oldX;
+                yd = oldY;
+                zd = oldZ;
+                this.bb.set(aabbCopy);
+            }
+        }
         //fix for entity jitter when blasted by cannonballs (can cause some client-side jitter when entity is under a ceiling. unsure exactly why)
         if (!this.world.isClientSide || this instanceof Player || !(this instanceof Mob)) {
-            this.x = (bb.minX + bb.maxX) / 2D;
-            this.y = (bb.minY + (double) heightOffset) - (double) ySlideOffset;
-            this.z = (bb.minZ + bb.maxZ) / 2D;
-        }
-        horizontalCollision = oldXd != xd || oldZd != zd;
-        verticalCollision = oldYd != yd;
-        onGround = oldYd != yd && oldYd < 0.0D;
-        collision = horizontalCollision || verticalCollision;
+            this.x = (this.bb.minX + this.bb.maxX) / 2D;
+            this.y = (this.bb.minY + (double) this.heightOffset) - (double) this.ySlideOffset;
+            this.z = (this.bb.minZ + this.bb.maxZ) / 2D;
+        }
+        this.horizontalCollision = oldXd != xd || oldZd != zd;
+        this.verticalCollision = oldYd != yd;
+        this.onGround = oldYd != yd && oldYd < 0.0D;
+        this.collision = this.horizontalCollision || this.verticalCollision;
         checkOnWater(false);
-        checkFallDamage(yd, onGround);
-        if(oldXd != xd)
-        {
+        checkFallDamage(yd, this.onGround);
+        if (oldXd != xd) {
             this.xd = 0.0D;
         }
-        if(oldYd != yd)
-        {
+        if (oldYd != yd) {
             this.yd = 0.0D;
         }
-        if(oldZd != zd)
-        {
+        if (oldZd != zd) {
             this.zd = 0.0D;
         }
         double d10 = this.x - d3;
         double d12 = this.z - d4;
-        if(makeStepSound() && !isSneaking() && vehicle == null) {
-            walkDist += (double) MathHelper.sqrt(d10 * d10 + d12 * d12) * 0.6;
-            
+        if (makeStepSound() && !isSneaking() && this.vehicle == null) {
+            this.walkDist += (double) MathHelper.sqrt(d10 * d10 + d12 * d12) * 0.6;
+
             // Tiny bounding box
-            AABB boundingBox = AABB.fromPool(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01, this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
+            AABBdc boundingBox = new AABBd(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01, this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
 
             int blockX = MathHelper.floor(this.x);
-            int blockY = MathHelper.floor(boundingBox.minY);
+            int blockY = MathHelper.floor(boundingBox.minY());
             int blockZ = MathHelper.floor(this.z);
 
             Block<?> blockWalkedOn = null;
 
-            blockCheck: for (int x = blockX - 1; x <= blockX + 1; x++) {
+            blockCheck:
+            for (int x = blockX - 1; x <= blockX + 1; x++) {
                 for (int z = blockZ - 1; z <= blockZ + 1; z++) {
                     for (int y = blockY - 1; y < blockY + 1; y++) {
-                        Block<?> block = world.getBlock(x, y, z);
-                        if(block == null) {
+                        Block<?> block = this.world.getBlock(x, y, z);
+                        if (block == null) {
                             continue;
                         }
 
-                        world.collidingBoundingBoxes.clear();
-                        block.getCollidingBoundingBoxes(world, x, y, z, boundingBox, world.collidingBoundingBoxes);
+                        this.world.collidingBoundingBoxes.clear();
+                        block.getCollidingBoundingBoxes(this.world, x, y, z, boundingBox, this.world.collidingBoundingBoxes);
 
-                        if(!world.collidingBoundingBoxes.isEmpty()) {
+                        if (!this.world.collidingBoundingBoxes.isEmpty()) {
                             blockWalkedOn = block;
                             blockX = x;
                             blockY = y;
